# IUS spec file for php56u-pecl-apcu, forked from:
#
# spec file for php-pecl-apcu
#
# Copyright (c) 2013 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/3.0/
#
# Please, preserve the changelog entries
#

%global pecl_name apcu
%global with_zts  0%{?__ztsphp:1}
%global php_base php55u
%global ini_name  40-%{pecl_name}.ini

Name:           %{php_base}-pecl-%{pecl_name}
Summary:        APC User Cache
Version:        4.0.10
Release:        1.ius%{?dist}
Source0:        http://pecl.php.net/get/%{pecl_name}-%{version}.tgz
Source1:        %{pecl_name}.ini
Source2:        %{pecl_name}-panel.conf
Source3:        %{pecl_name}.conf.php

License:        PHP
Group:          Development/Languages
URL:            http://pecl.php.net/package/APCu

BuildRequires:  %{php_base}-devel
BuildRequires:  %{php_base}-pear
BuildRequires:  pcre-devel

Requires(post): %{php_base}-pear
Requires(postun): %{php_base}-pear
Requires:       %{php_base}(zend-abi) = %{php_zend_api}
Requires:       %{php_base}(api) = %{php_core_api}

# provide the stock name
Provides:       php-pecl-%{pecl_name} = %{version}-%{release}
Provides:       php-pecl-%{pecl_name}%{?_isa} = %{version}-%{release}

# provide the stock and IUS names without pecl
Provides:       php-%{pecl_name} = %{version}-%{release}
Provides:       php-%{pecl_name}%{?_isa} = %{version}-%{release}
Provides:       %{php_base}-%{pecl_name} = %{version}-%{release}
Provides:       %{php_base}-%{pecl_name}%{?_isa} = %{version}-%{release}

# provide the stock and IUS names in pecl() format
Provides:       php-pecl(%{pecl_name}) = %{version}-%{release}
Provides:       php-pecl(%{pecl_name})%{?_isa} = %{version}-%{release}
Provides:       %{php_base}-pecl(%{pecl_name}) = %{version}-%{release}
Provides:       %{php_base}-pecl(%{pecl_name})%{?_isa} = %{version}-%{release}

# conflict with the stock name
Conflicts:      php-pecl-%{pecl_name} < %{version}

# Same provides than APC, this is a drop in replacement
Provides:       php-apc = %{version}
Provides:       php-apc%{?_isa} = %{version}
Provides:       php-pecl-apc = %{version}
Provides:       php-pecl-apc%{?_isa} = %{version}
Provides:       php-pecl(APC) = %{version}
Provides:       php-pecl(APC)%{?_isa} = %{version}
Provides:       %{php_base}-apc = %{version}
Provides:       %{php_base}-apc%{?_isa} = %{version}
Provides:       %{php_base}-pecl-apc = %{version}
Provides:       %{php_base}-pecl-apc%{?_isa} = %{version}
Provides:       %{php_base}-pecl(APC) = %{version}
Provides:       %{php_base}-pecl(APC)%{?_isa} = %{version}

%if 0%{?fedora} < 20 && 0%{?rhel} < 7
# Filter private shared
%{?filter_provides_in: %filter_provides_in %{_libdir}/.*\.so$}
%{?filter_setup}
%endif


%description
APCu is userland caching: APC stripped of opcode caching in preparation
for the deployment of Zend OPcache as the primary solution to opcode
caching in future versions of PHP.

APCu has a revised and simplified codebase, by the time the PECL release
is available, every part of APCu being used will have received review and
where necessary or appropriate, changes.

Simplifying and documenting the API of APCu completely removes the barrier
to maintenance and development of APCu in the future, and additionally allows
us to make optimizations not possible previously because of APC's inherent
complexity.

APCu only supports userland caching (and dumping) of variables, providing an
upgrade path for the future. When O+ takes over, many will be tempted to use
3rd party solutions to userland caching, possibly even distributed solutions;
this would be a grave error. The tried and tested APC codebase provides far
superior support for local storage of PHP variables.


%package devel
Summary:       APCu developer files (header)
Group:         Development/Libraries
Requires:      %{name}%{?_isa} = %{version}-%{release}
Requires:      %{php_base}-devel%{?_isa}
Conflicts:     php-pecl-%{pecl_name}-devel < %{version}
Provides:      php-pecl-%{pecl_name}-devel = %{version}-%{release}
Provides:      php-pecl-%{pecl_name}-devel%{?_isa} = %{version}-%{release}
Provides:      php-pecl-apc-devel = %{version}-%{release}
Provides:      php-pecl-apc-devel%{?_isa} = %{version}-%{release}

%description devel
These are the files needed to compile programs using APCu.


%package -n apcu-panel55u
Summary:       APCu control panel
Group:         Applications/Internet
BuildArch:     noarch
Requires:      %{name} = %{version}-%{release}
Requires:      mod_php55u
Requires:      %{php_base}-gd
Conflicts:     apcu-panel < %{version}
Provides:      apcu-panel = %{version}
Provides:      apc-panel = %{version}

%description -n apcu-panel55u
This package provides the APCu control panel, with Apache
configuration, available on http://localhost/apcu-panel/


%prep
%setup -qc
mv %{pecl_name}-%{version} NTS

cd NTS

# Sanity check, really often broken
extver=$(sed -n '/#define PHP_APCU_VERSION/{s/.* "//;s/".*$//;p}' php_apc.h)
if test "x${extver}" != "x%{version}"; then
   : Error: Upstream extension version is ${extver}, expecting %{version}.
   exit 1
fi
cd ..

%if %{with_zts}
# duplicate for ZTS build
cp -pr NTS ZTS
%endif

# Fix path to configuration file
sed -e s:apc.conf.php:%{_sysconfdir}/apcu-panel/conf.php:g \
    -i  NTS/apc.php


%build
cd NTS
%{_bindir}/phpize
%configure --with-php-config=%{_bindir}/php-config
make %{?_smp_mflags}

%if %{with_zts}
cd ../ZTS
%{_bindir}/zts-phpize
%configure --with-php-config=%{_bindir}/zts-php-config
make %{?_smp_mflags}
%endif


%install
# Install the NTS stuff
make -C NTS install INSTALL_ROOT=%{buildroot}
install -D -m 644 %{SOURCE1} %{buildroot}%{php_inidir}/%{ini_name}

%if %{with_zts}
# Install the ZTS stuff
make -C ZTS install INSTALL_ROOT=%{buildroot}
install -D -m 644 %{SOURCE1} %{buildroot}%{php_ztsinidir}/%{ini_name}
%endif

# Install the package XML file
install -D -m 644 package.xml %{buildroot}%{pecl_xmldir}/%{name}.xml

# Install the Control Panel
# Pages
install -D -m 644 -p NTS/apc.php  \
        %{buildroot}%{_datadir}/apcu-panel/index.php
#add apc.php to main package for user configured non Apache webservers
install -D -m 644 -p NTS/apc.php  %{buildroot}%{pecl_docdir}/%{pecl_name}/apc.php
# Apache config
install -D -m 644 -p %{SOURCE2} \
        %{buildroot}%{_sysconfdir}/httpd/conf.d/apcu-panel.conf
# Panel config
install -D -m 644 -p %{SOURCE3} \
        %{buildroot}%{_sysconfdir}/apcu-panel/conf.php

# Test & Documentation
for i in $(grep 'role="test"' package.xml | sed -e 's/^.*name="//;s/".*$//')
do install -Dpm 644 NTS/$i %{buildroot}%{pecl_testdir}/%{pecl_name}/$i
done
for i in $(grep 'role="doc"' package.xml | sed -e 's/^.*name="//;s/".*$//')
do install -Dpm 644 NTS/$i %{buildroot}%{pecl_docdir}/%{pecl_name}/$i
done


%check
cd NTS

# Check than both extensions are reported (BC mode)
%{__php} -n -d extension_dir=modules -d extension=apcu.so -m | grep 'apcu'
%{__php} -n -d extension_dir=modules -d extension=apcu.so -m | grep 'apc$'

# Upstream test suite for NTS extension
TEST_PHP_EXECUTABLE=%{_bindir}/php \
TEST_PHP_ARGS="-n -d extension_dir=$PWD/modules -d extension=%{pecl_name}.so" \
NO_INTERACTION=1 \
REPORT_EXIT_STATUS=1 \
%{__php} -n run-tests.php

%if %{with_zts}
cd ../ZTS

%{__ztsphp}    -n -d extension_dir=modules -d extension=apcu.so -m | grep 'apcu'
%{__ztsphp}    -n -d extension_dir=modules -d extension=apcu.so -m | grep 'apc$'

# Upstream test suite for ZTS extension
TEST_PHP_EXECUTABLE=%{__ztsphp} \
TEST_PHP_ARGS="-n -d extension_dir=$PWD/modules -d extension=%{pecl_name}.so" \
NO_INTERACTION=1 \
REPORT_EXIT_STATUS=1 \
%{__ztsphp} -n run-tests.php
%endif


%post
%{pecl_install} %{pecl_xmldir}/%{name}.xml >/dev/null || :


%postun
if [ $1 -eq 0 ] ; then
    %{pecl_uninstall} %{pecl_name} >/dev/null || :
fi


%files
%doc %{pecl_docdir}/%{pecl_name}
%{pecl_xmldir}/%{name}.xml
%config(noreplace) %{php_inidir}/%{ini_name}
%{php_extdir}/%{pecl_name}.so
%if %{with_zts}
%{php_ztsextdir}/%{pecl_name}.so
%config(noreplace) %{php_ztsinidir}/%{ini_name}
%endif


%files devel
%doc %{pecl_testdir}/%{pecl_name}
%{php_incldir}/ext/%{pecl_name}
%if %{with_zts}
%{php_ztsincldir}/ext/%{pecl_name}
%endif


%files -n apcu-panel55u
# Need to restrict access, as it contains a clear password
%attr(550,apache,root) %dir %{_sysconfdir}/apcu-panel
%config(noreplace) %{_sysconfdir}/apcu-panel/conf.php
%config(noreplace) %{_sysconfdir}/httpd/conf.d/apcu-panel.conf
%{_datadir}/apcu-panel


%changelog
* Wed Dec 09 2015 Ben Harper <ben.harper@rackspace.com> - 4.0.10-1.ius
- Latest upstream

* Tue Nov 24 2015 Carl George <carl.george@rackspace.com> - 4.0.8-1.ius
- Latest upstream

* Thu Apr 16 2015 Ben Harper <ben.harper@rackspace.com> - 4.0.7-4.ius
- add apc.php to main package for user configured non Apache webservers

* Thu Jan 08 2015 Carl George <carl.george@rackspace.com> - 4.0.7-3.ius
- Remove redundant dependency on httpd

* Wed Oct 15 2014 Carl George <carl.george@rackspace.com> - 4.0.7-2.ius
- Remove conflicts on non-existing packages

* Mon Oct 13 2014 Carl George <carl.george@rackspace.com> - 4.0.7-1.ius
- Latest upstream

* Fri Oct 10 2014 Carl George <carl.george@rackspace.com> - 4.0.6-2.ius
- Directly require the correct pear package, not /usr/bin/pecl
- Conflict with stock packages
- Add missing provides
- Add numerical prefix to extension configuration file
- Install doc in pecl doc_dir
- Install tests in pecl test_dir (in devel)
- Fix perm on config dir

* Mon Jun 16 2014 Carl George <carl.george@rackspace.com> - 4.0.6-1.ius
- Latest upstream

* Wed Jun 11 2014 Carl George <carl.george@rackspace.com> - 4.0.5-1.ius
- Latest upstream

* Thu Apr 03 2014 Ben Harper <ben.harper@rackspace.com> - 4.0.4-2.ius
- updated requires from php-gd to %{php_base}-gd and mod_php to mod_php55u

* Wed Apr 02 2014 Ben Harper <ben.harper@rackspace.com> - 4.0.4-1.ius
- Latest sources from upstream
- update Sanity check in prep

* Mon Dec 16 2013 Ben Harper <ben.harper@rackspace.com> - 4.0.2-1.ius
- porting to IUS

* Tue Apr 30 2013 Remi Collet <remi@fedoraproject.org> - 4.0.1-1
- Update to 4.0.1
- add missing scriptlet
- fix Conflicts

* Thu Apr 25 2013 Remi Collet <remi@fedoraproject.org> - 4.0.0-2
- fix segfault when used from command line

* Wed Mar 27 2013 Remi Collet <remi@fedoraproject.org> - 4.0.0-1
- first pecl release
- rename from php-apcu to php-pecl-apcu

* Tue Mar 26 2013 Remi Collet <remi@fedoraproject.org> - 4.0.0-0.4.git4322fad
- new snapshot (test before release)

* Mon Mar 25 2013 Remi Collet <remi@fedoraproject.org> - 4.0.0-0.3.git647cb2b
- new snapshot with our pull request
- allow to run test suite simultaneously on 32/64 arch
- build warning free

* Mon Mar 25 2013 Remi Collet <remi@fedoraproject.org> - 4.0.0-0.2.git6d20302
- new snapshot with full APC compatibility

* Sat Mar 23 2013 Remi Collet <remi@fedoraproject.org> - 4.0.0-0.1.git44e8dd4
- initial package, version 4.0.0
